﻿Public Class Form1

    Private mainGraphics As Graphics
    Private Units As New List(Of Unit)
    '64ビットOSでLoadイベント処理中の例外が捕捉されない問題があるのでShownを使います。
    Private Sub Form1_Shown(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Shown
        Init()
        Timer1.Enabled = True
    End Sub
    Private Sub Init()

        '▼描画用のGraphicsクラスの確保(技術的な処理)
        If mainGraphics Is Nothing Then
            '初回のみ生成
            Dim bmp As New Bitmap(Me.ClientRectangle.Width, Me.ClientRectangle.Height)
            Me.BackgroundImage = bmp
            mainGraphics = Graphics.FromImage(bmp)
        End If

        '▼敵キャラクター

        '１体目
        Dim zako1 As New ZakoUnit
        zako1.Location = New Point(10, 0) '初期位置
        Units.Add(zako1)

        '２体目
        Dim zako2 As New ZakoUnit
        zako2.Location = New Point(200, -128) '初期位置
        Units.Add(zako2)

        '３体目
        Dim naname1 As New NanameUnit
        naname1.Location = New Point(0, -100)
        Units.Add(naname1)

    End Sub
    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick

        'いったん全体を黒で塗りつぶす
        mainGraphics.Clear(Color.Black)

        '登録されているすべてのUnitに対して、MoveとDrawを呼び出す。
        For Each unit As Unit In Units
            If unit.IsAlive Then
                unit.Move() 'unitの座標更新
                unit.Draw(mainGraphics) 'unitの描画(この時点では画面には反映されない)
            End If
        Next

        '最新の状態を画面に描画する。
        Me.Invalidate()
    End Sub

End Class
