﻿Public Class Unit

    'このユニットの画像
    Protected MainImage As Image

    'MainImageの透明色の設定
    Protected imageSetting As New Imaging.ImageAttributes

    '現在の座標
    Public Location As Point
    Public Sub New(ByVal imageFileName As String)
        '画像の読み込み
        MainImage = Image.FromFile(imageFileName)
        '紫を透明色に指定(この設定が使用されるのはDrawメソッド内)
        imageSetting.SetColorKey(Color.FromArgb(255, 0, 255), Color.FromArgb(255, 0, 255))
    End Sub
    ''' <summary>
    ''' ユニットを移動させます。フレームごとに必ず呼び出してください。
    ''' 移動の必要があるかないかも含めてすべてMoveメソッドの内部で処理します。
    ''' つまり、Moveメソッドを呼び出してもまったく移動しない場合もあり得ます。
    ''' </summary>
    Public Overridable Sub Move()
        '
    End Sub
    ''' <summary>
    ''' ユニットの現在の位置情報を返します。
    ''' これはLocationが保持する値に幅と高さを加えた情報です。
    ''' </summary>
    Public ReadOnly Property Rectangle As Rectangle
        Get
            Return New Rectangle(Location, MainImage.Size)
        End Get
    End Property
    ''' <summary>
    ''' ユニットを描画します。フレームごとに必ず呼び出してください。
    ''' </summary>
    Public Overridable Sub Draw(ByVal g As Graphics)
        '現在の位置に画像を描画
        g.DrawImage(MainImage, Rectangle, 0, 0, Rectangle.Width, Rectangle.Height, GraphicsUnit.Pixel, imageSetting)
    End Sub
    ''' <summary>
    ''' ユニットの生死を判断します。Falseのときこのユニットは死んでいます。
    ''' </summary>
    Public Overridable ReadOnly Property IsAlive() As Boolean
        Get
            'この段階では常にTrueを返しておきます。(つまり、永遠に死なない。)
            Return True
        End Get
    End Property

End Class
